Program Goroud_Shading;
uses crt;

const M=350;
      p=350*65536;

type TScreen=array[0..199,0..319] of byte;
     T3D=record
              x,y,z : longint;
         end;
     TPoint=record
                  map : T3D;
                  coords : T3D;
                  screen : record
                                 a : byte;
                                 x,y : integer;
                           end;
                  normal : T3D;
                  newnormal : T3D;
            end;
     TPoly=record
                 pointnum : byte;
                 points : array[1..4] of word;
                 normal : T3D;
                 newnormal : T3D;
           end;
     T3DCube=record
                 points : array[1..8] of TPoint;
                 polys : array[1..6] of TPoly;
             end;

var Screen : TScreen absolute $0a000:0000;
    ScreenBuf : ^TScreen;
    sint,cost : array[0..511] of integer;
    Lines : array[0..199] of
            record
                 x0,x1 : integer;
                 a0,a1 : byte;
            end;
    MaxY,MinY : word;
    a,b : integer;
    Cube : T3DCube;
    Light : T3D;

Procedure SetPal;
var i : integer;
begin
     Port[$03c8]:=0;
     for i:=0 to 63 do
     begin
          Port[$03c9]:=0;{round((i+25)/1.4);}
          Port[$03c9]:=0;{round((i+25)/1.4);}
          Port[$03c9]:=round((i+25)/1.4);
     end;
end;

Procedure FillTabs;
var i: integer;
begin
     for i:=0 to 511 do
     begin
          sint[i]:=round(sin(i*2*pi/511)*256);
          cost[i]:=round(cos(i*2*pi/511)*256);
     end;
end;

procedure clearbuf; assembler;
asm
   push es
   les di,ScreenBuf
   mov cx,32000
   xor ax,ax
   rep stosw
   pop es
end;

procedure display; assembler;
asm
   push es
   push ds
   mov ax,seg Screen
   mov es,ax
   mov di,offset Screen
   lds si,ScreenBuf
   mov cx,32000
   rep movsw
   pop ds
   pop es
end;

Procedure InitCube;
var i,j,p : integer;
    nx,ny,nz : longint;
    f,l : real;
    p1,p2,p3 : T3D;
    pp: array[1..8,1..4] of word;
    pn: array[1..8] of byte;
begin
     {pontok megadasa 65536-al felszorozva}
     Cube.points[1].map.x:=-50*65536;Cube.points[1].map.y:=50*65536;
     Cube.points[1].map.z:=50*65536;
     Cube.points[2].map.x:=50*65536;Cube.points[2].map.y:=50*65536;
     Cube.points[2].map.z:=50*65536;
     Cube.points[3].map.x:=50*65536;Cube.points[3].map.y:=-50*65536;
     Cube.points[3].map.z:=50*65536;
     Cube.points[4].map.x:=-50*65536;Cube.points[4].map.y:=-50*65536;
     Cube.points[4].map.z:=50*65536;
     Cube.points[5].map.x:=-50*65536;Cube.points[5].map.y:=50*65536;
     Cube.points[5].map.z:=-50*65536;
     Cube.points[6].map.x:=50*65536;Cube.points[6].map.y:=50*65536;
     Cube.points[6].map.z:=-50*65536;
     Cube.points[7].map.x:=50*65536;Cube.points[7].map.y:=-50*65536;
     Cube.points[7].map.z:=-50*65536;
     Cube.points[8].map.x:=-50*65536;Cube.points[8].map.y:=-50*65536;
     Cube.points[8].map.z:=-50*65536;

     {Poligonok megadasa}
     Cube.Polys[1].points[1]:=1;Cube.Polys[1].points[2]:=2;
     Cube.Polys[1].points[3]:=3;Cube.Polys[1].points[4]:=4;
     Cube.Polys[2].points[1]:=5;Cube.Polys[2].points[2]:=6;
     Cube.Polys[2].points[3]:=2;Cube.Polys[2].points[4]:=1;
     Cube.Polys[3].points[1]:=2;Cube.Polys[3].points[2]:=6;
     Cube.Polys[3].points[3]:=7;Cube.Polys[3].points[4]:=3;
     Cube.Polys[4].points[1]:=4;Cube.Polys[4].points[2]:=3;
     Cube.Polys[4].points[3]:=7;Cube.Polys[4].points[4]:=8;
     Cube.Polys[5].points[1]:=5;Cube.Polys[5].points[2]:=1;
     Cube.Polys[5].points[3]:=4;Cube.Polys[5].points[4]:=8;
     Cube.Polys[6].points[1]:=8;Cube.Polys[6].points[2]:=7;
     Cube.Polys[6].points[3]:=6;Cube.Polys[6].points[4]:=5;

     {poligonok normalvektorai}
     for i:=1 to 6 do
     begin
          p1.x:=Cube.points[Cube.polys[i].points[1]].map.x;
          p1.y:=Cube.points[Cube.polys[i].points[1]].map.y;
          p1.z:=Cube.points[Cube.polys[i].points[1]].map.z;
          p2.x:=Cube.points[Cube.polys[i].points[2]].map.x;
          p2.y:=Cube.points[Cube.polys[i].points[2]].map.y;
          p2.z:=Cube.points[Cube.polys[i].points[2]].map.z;
          p3.x:=Cube.points[Cube.polys[i].points[3]].map.x;
          p3.y:=Cube.points[Cube.polys[i].points[3]].map.y;
          p3.z:=Cube.points[Cube.polys[i].points[3]].map.z;

          nx:=(((p1.y-p2.y) div 256)*((p1.z-p3.z) div 256))-(((p1.z-p2.z) div 256)*((p1.y-p3.y) div 256));
          ny:=(((p1.z-p2.z) div 256)*((p1.x-p3.x) div 256))-(((p1.x-p2.x) div 256)*((p1.z-p3.z) div 256));
          nz:=(((p1.x-p2.x) div 256)*((p1.y-p3.y) div 256))-(((p1.y-p2.y) div 256)*((p1.x-p3.x) div 256));

          l:=sqrt((nx/256)*(nx/256)+(ny/256)*(ny/256)+(nz/256)*(nz/256))/256;
          if l>0 then
          begin
               Cube.Polys[i].normal.x:=round(nx/l);
               Cube.Polys[i].normal.y:=round(ny/l);
               Cube.Polys[i].normal.z:=round(nz/l);
          end
          else
          begin
               Cube.Polys[i].normal.x:=0;
               Cube.Polys[i].normal.y:=0;
               Cube.Polys[i].normal.z:=0;
          end;
     end;

     {pontokhoz tartozo sikok kigyujtese}
     for p:=1 to 8 do pn[p]:=0;
     for p:=1 to 8 do
     begin
      for i:=1 to 6 do
      begin
       for j:=1 to 4 do
        if Cube.polys[i].points[j]=p then
        begin
         pn[p]:=pn[p]+1;
         pp[p,pn[p]]:=i;
        end;
      end;
     end;

     {A pontokhoz tartozo normalvektorok kiatlagolasa a kornyezo sikok
      normalvektoraibol:}
     for p:=1 to 8 do
     begin
      nx:=0;ny:=0;nz:=0;
      for j:=1 to pn[p] do
      begin
       nx:=nx+Cube.Polys[pp[p,j]].normal.x;
       ny:=ny+Cube.Polys[pp[p,j]].normal.y;
       nz:=nz+Cube.Polys[pp[p,j]].normal.z;
      end;
      l:=sqrt((nx/256)*(nx/256)+(ny/256)*(ny/256)+(nz/256)*(nz/256))/256;
      if l>0 then
      begin
           Cube.Points[p].normal.x:=round(nx/l);
           Cube.Points[p].normal.y:=round(ny/l);
           Cube.Points[p].normal.z:=round(nz/l);
      end
      else
      begin
           Cube.Points[p].normal.x:=0;
           Cube.Points[p].normal.y:=0;
           Cube.Points[p].normal.z:=0;
      end;
     end;
end;

procedure rotate;
var psa,pca,psb,pcb,pcs,pss,pcc,psc : longint;
    i : integer;
begin
 psa:=sint[a];
 pca:=cost[a];
 psb:=sint[b];
 pcb:=cost[b];
 pcs:=(pca*psb) div 256;
 pss:=(psa*psb) div 256;
 pcc:=(pca*pcb) div 256;
 psc:=(psa*pcb) div 256;

 with Cube do
 begin
  for i:=1 to 8 do
  begin
   {koordinatak forgatasa}
   Points[i].coords.X:=(-Points[i].map.X*psa+Points[i].map.Y*pca) div 256;
   Points[i].coords.Y:=(-Points[i].map.X*pcs-Points[i].map.Y*pss+Points[i].map.Z*pcb) div 256;
   Points[i].coords.Z:=(-Points[i].map.X*pcc-Points[i].map.Y*psc-Points[i].map.Z*psb) div 256;
   {normalvektorok forgatasa}
   Points[i].newnormal.X:=(-Points[i].normal.X*psa+Points[i].normal.Y*pca) div 256;
   Points[i].newnormal.Y:=(-Points[i].normal.X*pcs-Points[i].normal.Y*pss+Points[i].normal.Z*pcb) div 256;
   Points[i].newnormal.Z:=(-Points[i].normal.x*pcc-Points[i].normal.Y*psc-Points[i].normal.Z*psb) div 256;
   {lekepezes}
   Points[i].screen.X:=longint(160)+((M*(Points[i].coords.X div 256)) div ((P+Points[i].coords.Z) div 256));
   Points[i].screen.Y:=longint(100)+((M*(Points[i].coords.Y div 256)) div ((P+Points[i].coords.Z) div 256));
  end;
  for i:=1 to 6 do
  begin
   {sikok normalvektorainak forgatasa}
   Polys[i].newnormal.X:=(-Polys[i].normal.X*psa+Polys[i].normal.Y*pca) div 256;
   Polys[i].newnormal.Y:=(-Polys[i].normal.X*pcs-Polys[i].normal.Y*pss+Polys[i].normal.Z*pcb) div 256;
   Polys[i].newnormal.Z:=(-Polys[i].normal.x*pcc-Polys[i].normal.Y*psc-Polys[i].normal.Z*psb) div 256;
  end;
 end;
end;

{A tomb feltoltese,
 Y iranyu interpolacio}
Procedure Gline(p1,p2: word);
var StepX,X : longint;
    StepA,A : integer;
    dist : word;
    x1,x2,a1,a2,y1,y2 : integer;
    y : integer;
begin
      x1:=Cube.points[p1].screen.x;
      x2:=Cube.points[p2].screen.x;
      y1:=Cube.points[p1].screen.y;
      y2:=Cube.points[p2].screen.y;
      a1:=Cube.points[p1].screen.a;
      a2:=Cube.points[p2].screen.a;

      { a koruljarasi iranyunk miatt, a lathato poligonok bal szelen az
        y1<y2 mindig igaz}
      {bal oldalt szamoljuk}
      if y1<y2 then
      begin
            if (y2<0) or (y1>199) then exit;
            dist:=y2-y1+1;
            StepX:=(longint(x2-x1) shl 16) div dist; {X 16 bittel fel} {16.16}
            StepA:=((a2-a1) shl 8) div dist;         {A 8 bittel fel}  {8.8}
            X:=longint(x1) shl 16;                   {X 16 bittel fel}
            A:=a1 shl 8;                             {A 8 bittel fel}
            while y1<0 do
            begin
                  X:=X+StepX;
                  A:=A+StepA;
                  inc(y1);
            end;
            if y2>199 then y2:=199;
            if y1<MinY then MinY:=y1;
            if y2>MaxY then MaxY:=y2;
            for y:=y1 to y2 do
            begin
                  {bal oldal, scanline eleje-> x0 a0}
                  Lines[y].x0:=X shr 16; {16 bittel vissza}
                  Lines[y].a0:=A shr 8;  {8 bittel vissza}
                  X:=X+StepX;
                  A:=A+StepA;
            end;
     end;
     { a koruljarasi iranyunk miatt, a lathato poligonok jobb szelen az
       y1>y2 mindig igaz}
     {jobb oldalt szamoljuk}
     if y1>y2 then
     begin
           if (y1<0) or (y2>199) then exit;
           dist:=y1-y2+1;
           StepX:=(longint(x1-x2) shl 16) div dist;
           StepA:=((a1-a2) shl 8) div dist;
           A:=a2 shl 8;
           X:=longint(x2) shl 16;
           while y2<0 do
           begin
                 X:=X+StepX;
                 A:=A+StepA;
                 inc(y2);
           end;
           if y1>199 then y1:=199;
           if y2<MinY then MinY:=y2;
           if y1>MaxY then MaxY:=y1;
           for y:=y2 to y1 do
           begin
                 {jobb oldal, scanline vege ->x1,a1}
                 Lines[y].x1:=X shr 16; {16 bittel vissza}
                 Lines[y].a1:=A shr 8;  {8 bittel vissza}
                 X:=X+StepX;
                 A:=A+StepA;
           end;
     end;
end;

{ A Scanline-ok megrajzolasa,
  X iranyu interpolacio}
procedure GFill;
var StepA,A : integer;
    x,x0,x1 : integer;
    a0,a1 : integer;
    dist : integer;
    y : word;
begin
    for y:=MinY to MaxY do
    begin
          x0:=Lines[y].x0;
          x1:=Lines[y].x1;
          a0:=Lines[y].a0;
          a1:=Lines[y].a1;
          {scanline hossza}
          dist:=x1-x0+1;
          if (x1<0) or (x0>319) or (dist<1) then exit;
          {lepeskoz}
          StepA:=((a1-a0) shl 8) div dist; {8 bittel fel -> 8.8}
          a:=a0 shl 8;                     {8 bittel fel -> 8.8}
          {Clipping}
          while x0<0 do
          begin
                a:=a+StepA;
                inc(x0);
          end;
          if x1>319 then x1:=319;
          {Scanline}
          for x:=x0 to x1 do
          begin
                screenbuf^[y,x]:=a shr 8; {8 bittel vissza}
                a:=a+StepA;
          end;
    end;
end;

Procedure Draw;
var i : integer;
begin
     for i:=1 to 6 do
     begin
          if Cube.Polys[i].newnormal.z>12000 then
          begin
               Gline(Cube.Polys[i].points[1], Cube.Polys[i].points[2]);
               Gline(Cube.Polys[i].points[2], Cube.Polys[i].points[3]);
               Gline(Cube.Polys[i].points[3], Cube.Polys[i].points[4]);
               Gline(Cube.Polys[i].points[4], Cube.Polys[i].points[1]);
               GFill; MinY:=199; MaxY:=0;
          end;
     end;
end;

Procedure CalcLight;
var i: integer;
    a : longint;
begin
     with Cube do
          for i:=1 to 8 do
          begin
              a:=((Points[i].newnormal.x div 256)*(Light.x div 256)+
                  (Points[i].newnormal.y div 256)*(Light.y div 256)+
                  (Points[i].newnormal.z div 256)*(Light.z div 256)) div 1024;
                 if a>63 then a:=63;
                 if a<0 then a:=0;
                 Points[i].screen.a:=a;
          end;
end;

Begin
      Light.x:=0;Light.y:=0;Light.z:=65536; {a feny a szemlelo felol indul}

      asm
          mov ax,13h
          int 10h
      end;

      SetPal;
      GetMem(ScreenBuf,64000);
      FillTabs;
      InitCube;
      Repeat
            rotate;
            CalcLight;
            clearbuf;
            draw;
            display;
            a:=(a+1) and 511;
            b:=(b+2) and 511;
            delay(50);
      until keypressed;
      readkey;

      FreeMem(ScreenBuf,64000);

      asm
          mov ax,03h
          int 10h
      end;
End.